package fr.doap.llog;

import java.util.*;

public class Dict<T> {
	
	public void put(String aKey, T aValue) {
		if (aKey == null || aKey.length() == 0) mValue = aValue;
		else {
			String[] lS = aKey.split("[.]", 2);
			Dict<T> lD = mDict.get(lS[0]);
			if (lD == null) {
				lD = new Dict<>();
				mDict.put(lS[0], lD);
			}
			if (lS.length > 1) lD.put(lS[1], aValue);
			else lD.put("", aValue);
		}
	}
	
	public T get(String aKey) {
		if (aKey == null || aKey.length() == 0) return mValue;
		else {
			String[] lS = aKey.split("[.]", 2);
			Dict<T> lD = mDict.get(lS[0]);
			if (lD == null) return mValue;
			else {
				T lT = lD.mValue;
				if (lS.length > 1) lT = lD.get(lS[1]);
				if (lT == null) return mValue;
				else return lT;
			}
		}
	}
	
	@Override
	public String toString() {
		return "\n{\n"+toString(0)+"}";
	}
	
	private String toString(int aI) {
		String lR = ": "+ mValue+"\n";
		for (Map.Entry<String, Dict<T>> me: mDict.entrySet()) lR += spc(aI+1)+me.getKey()+me.getValue().toString(aI+1);
		return lR;
	}

	private String spc(int aI) {
		String l = "";
		for (int i=0; i<aI; i++) l += "   ";
		return l;
	}
	
	private Map<String, Dict<T>>	mDict = new HashMap<>();
	private T 						mValue;
}
