package fr.doap.llog;

import java.io.*;
import java.util.Properties;

public class L {
	static final public int		ALL = 		0;
	static final public int		TRACE = 	100;
	static final public int		VERBOSE = 	200;
	static final public int		DEBUG = 	300;
	static final public int		INFO = 		400;
	static final public int		CONFIG = 	500;
	static final public int		WARN = 		600;
	static final public int		ERROR = 	700;
	static final public int		FATAL = 	800;
	static final public int		OFF = 		1000;
	
	static public void filter(String aKey, Filter aFilter) {
		mLooper.put(aKey,aFilter);
	}
	
	static public void setLogger(ILogger aLogger) {
		mLooper.setLogger(aLogger);
	}
	
	static public String getSeverity(int aSeverity) {
		switch(aSeverity) {
			case TRACE: return "TRACE";
			case VERBOSE: return "VERBOSE";
			case DEBUG: return "DEBUG";
			case INFO: return "INFO";
			case CONFIG: return "CONFIG";
			case WARN: return "WARN";
			case ERROR: return "ERROR";
			case FATAL: return "FATAL";
		}
		return "?";
	}
	
	static public int getSeverity(String aSeverity) {
		switch(aSeverity) {
			case "ALL": return ALL;
			case "TRACE": return TRACE;
			case "VERBOSE": return VERBOSE;
			case "DEBUG": return DEBUG;
			case "INFO": return INFO;
			case "CONFIG": return CONFIG;
			case "WARN": return WARN;
			case "ERROR": return ERROR;
			case "FATAL": return FATAL;
			case "OFF": return OFF;
		}
		return -1;
	}
	
	static public void t(Throwable aThrowable, String aMsg, Object ... aArgs) 				{ l(TRACE, aThrowable, aMsg, aArgs); }
	static public void t(Throwable aThrowable)												{ l(TRACE, aThrowable, null); }
	static public void t(String aMsg, Object ... aArgs) 									{ l(TRACE, null, aMsg, aArgs); }
	
	static public void v(Throwable aThrowable, String aMsg, Object ... aArgs) 				{ l(VERBOSE, aThrowable, aMsg, aArgs); }
	static public void v(Throwable aThrowable)												{ l(VERBOSE, aThrowable, null); }
	static public void v(String aMsg, Object ... aArgs) 									{ l(VERBOSE, null, aMsg, aArgs); }
	
	static public void d(Throwable aThrowable, String aMsg, Object ... aArgs) 				{ l(DEBUG, aThrowable, aMsg, aArgs); }
	static public void d(Throwable aThrowable)												{ l(DEBUG, aThrowable, null); }
	static public void d(String aMsg, Object ... aArgs) 									{ l(DEBUG, null, aMsg, aArgs); }
	
	static public void i(Throwable aThrowable, String aMsg, Object ... aArgs) 				{ l(INFO, aThrowable, aMsg, aArgs); }
	static public void i(Throwable aThrowable)												{ l(INFO, aThrowable, null); }
	static public void i(String aMsg, Object ... aArgs) 									{ l(INFO, null, aMsg, aArgs); }
	
	static public void c(Throwable aThrowable, String aMsg, Object ... aArgs) 				{ l(CONFIG, aThrowable, aMsg, aArgs); }
	static public void c(Throwable aThrowable)												{ l(CONFIG, aThrowable, null); }
	static public void c(String aMsg, Object ... aArgs) 									{ l(CONFIG, null, aMsg, aArgs); }
	
	static public void w(Throwable aThrowable, String aMsg, Object ... aArgs) 				{ l(WARN, aThrowable, aMsg, aArgs); }
	static public void w(Throwable aThrowable)												{ l(WARN, aThrowable, null); }
	static public void w(String aMsg, Object ... aArgs) 									{ l(WARN, null, aMsg, aArgs); }
	
	static public void e(Throwable aThrowable, String aMsg, Object ... aArgs) 				{ l(ERROR, aThrowable, aMsg, aArgs); }
	static public void e(Throwable aThrowable)												{ l(ERROR, aThrowable, null); }
	static public void e(String aMsg, Object ... aArgs) 									{ l(ERROR, null, aMsg, aArgs); }
	
	static public void f(Throwable aThrowable, String aMsg, Object ... aArgs) 				{ l(FATAL, aThrowable, aMsg, aArgs); }
	static public void f(Throwable aThrowable)												{ l(FATAL, aThrowable, null); }
	static public void f(String aMsg, Object ... aArgs) 									{ l(FATAL, null, aMsg, aArgs); }
	
	static public LogMsg l(int aSeverity, Throwable aThrowable, String aMsg, Object ... aArgs) {
		String lMsg = aMsg;
		if (aArgs != null && aArgs.length > 0) lMsg = String.format(aMsg, aArgs);
		String lTag = null;
		if (lMsg.startsWith("#")) {
			String lP[] = lMsg.split("[ :,]+", 2);
			lTag = lP[0].substring(1);
			lMsg = lP[1];
		}
		LogMsg lLogMsg = new LogMsg(aSeverity, aThrowable, lTag, lMsg);
		mLooper.post(lLogMsg);
		return lLogMsg;
	}
	
	static private	LogLooper	mLooper = new LogLooper();
}
