package fr.doap.llog;

public class LogMsg {
	public long						mTime;
	public Throwable				mThrowable;
	public Thread					mCallerThread;

	public String					mMessage;
	public int						mSeverity;
	public String					mTag;
	
	public StackTraceElement[]		mSTE;


	public LogMsg(int aSeverity, Throwable aThrowable, String aTag, String aMsg) {
		mTime = System.currentTimeMillis();
		mThrowable = aThrowable;
		mCallerThread = Thread.currentThread();
		
		mMessage = aMsg;
		mTag = aTag;
		mSeverity = aSeverity;
		
		mSTE = Thread.currentThread().getStackTrace();
	}
	
	public int getCallerIndex() {
		int lI = mSTE.length-1;
		while (!mSTE[lI].getClassName().startsWith("fr.doap.llog.") && lI>=0) lI--;
		return lI+1;
	}
}